# -*- coding: utf-8 -*-
""" db tools

    Configuration tables for the application tools.
    
"""
tp_category = \
"Publication category associated to the record."

tp_collections = \
"List of collections separated by commma: LHCb Papers, LHCb Talks"

tp_controller = \
"The name of the web2py controller running the search: articles, proceedings,..."

tp_host = \
"Address of the invenio store where the search is performed."

tp_max_records = \
"Maximum number of records which can be retrieved from a search."

tp_ratio = \
"Parameter for fuzzy string search."

db.define_table("harvesters",
    Field("id_teams", db.teams, default=undef_id, label='Team'),
    Field("controller", "string", notnull=True, comment=tp_controller),
    Field("host", "string", notnull=True, default='cdsweb.cern.ch', comment=tp_host),
    Field("collections", "string", comment=tp_collections),
    Field("max_records", "integer", notnull=True, default=200, comment=tp_max_records),
    Field("ratio", "double", notnull=True, default=1.0, comment=tp_ratio),
    Field("id_categories", db.categories, default=undef_id, label='Category', comment=tp_category),
    migrate="harvesters.table")

db.harvesters.controller.requires = \
IS_IN_SET(['articles', 'proceedings', 'reports', 'talks'])

db.harvesters.id_categories.requires = \
IS_IN_DB(db, 'categories.id', 'categories.code')

db.harvesters.id_teams.requires = \
IS_IN_DB(db, 'teams.id', 'teams.team')

db.harvesters.ratio.requires = \
IS_FLOAT_IN_RANGE(0., 1.0)