# -*- coding: utf-8 -*-
""" widgets grids

"""
#
# add plugin to all grids
#
dbui.configure_grids(db, plugins=['pGridRowEditorConfirmDelete',
                                  'pGridRowEditorContextMenu',
                                  'pGridRowEditorDblClick',
                                  'pGridExport'])
#
# Polish categories grid
#
gridModifier = dbui.GridModifier('categories')
gridModifier.configure_column('code', width=10)
gridModifier.set_rownumbering()

gridModifier.append_filter(('code', 'contains', T('bla bla...')))
gridModifier.set_filters(plugins=['pFormToolTip'],
                         width=300)

#
# Define a column template for the publications grid
#
tpl = ['<b>{PublicationsTitle}</b><br>',
       '{PublicationsAuthors}',
       '<tpl if="PublicationsId_collaborations  &gt; 1">, {CollaborationsCollaboration}</tpl>',
       '<tpl if="PublicationsDoi">, {PublicationsDoi}</tpl>',
       '<tpl if="PublicationsId_publishers  &gt; 1">, {PublishersAbbreviation}',
           '<tpl if="PublicationsVolume"> {PublicationsVolume}</tpl>',
           '<tpl if="PublicationsYear"> ({PublicationsYear}) </tpl>',
           '<tpl if="PublicationsFirst_page"> {PublicationsFirst_page}</tpl>',
           '<tpl if="PublicationsLast_page">-{PublicationsLast_page}</tpl>',
       '</tpl>',
       '<tpl if="PublicationsConference_title"><br><br>{PublicationsConference_title}',
           '<tpl if="PublicationsConference_town"><br>{PublicationsConference_town}</tpl>',
           '<tpl if="CountriesCountry">, {CountriesCountry}</tpl>',
           '<tpl if="PublicationsConference_start">, {PublicationsConference_start}</tpl>',
           '<tpl if="PublicationsConference_end"> - {PublicationsConference_end}</tpl>',
           '<tpl if="PublicationsConference_url"><br>{PublicationsConference_url}</tpl>',
           '<br>%s: {PublicationsConference_speaker}' % T('Speaker'),
       '</tpl>',
       '<tpl if="PublicationsReport_numbers"><br><br>',
           '<tpl if="PublicationsId_reports &gt; 1">{ReportsType}, </tpl>',
           '{PublicationsReport_numbers}',
       '</tpl>'
       ]

gridModifier = dbui.GridModifier('publications')
gridModifier.append_plugins('pGridPaging', 'pGridExport', 'pGridMathJax')
gridModifier.merge_columns('title', 
                           'authors', 
                           'id_collaborations', 
                           'id_publishers',
                           'doi', 
                           'volume',
                           'first_page',
                           'last_page',
                           'conference_title',
                           'conference_url',
                           'conference_start',
                           'conference_end',
                           'conference_town',
                           'id_countries',
                           'conference_speaker',
                           'report_numbers',
                           'id_reports',
                           autohide=True,
                           header=T('Publication'),
                           position=0,
                           tpl=tpl,
                           width=700)

gridModifier.hide_columns('authors_cppm',
                          'e_print')

gridModifier.set_rownumbering()

#
# Setup a filter panel for the publication grid
#

gridModifier.append_filter(('year', '==', T('select publication for a given year')))
gridModifier.append_filter(('id_teams', '==', T('select publications for a given team')))
gridModifier.append_filter(('id_projects', '==', T('select publications for a given project')))
gridModifier.append_filter(('id_categories', '==', T('select publications with a given category code')))
gridModifier.append_filter(('authors_cppm', 'contains', T('select publications for a given CPPM author')))
gridModifier.append_filter(('countries.country', 'contains', T('blab blab ....')))

gridModifier.set_filters(plugins=['pFormToolTip'],
                         width=300)
