""" Author: R. Le Gac

"""
from extjs import TabPanel


def map_default(fields):
    """Map a list of field in the Ext.form.formPanel
    Return the items list for the Ext.form.FormPanel.
    
    """
    return fields


def map_tabpanel(fieldsets):
    """Map a list of fieldsets on a Ext.TabPanel.
    
    A tab is associated to each fieldset.
    the name of the tab is the name of the fieldset.
    Return the items list for the Ext.form.FormPanel.
    
    """
    
    tabpanel = TabPanel(activeTab=0,
                        defaults={'anchor': '98%'})
    
    for fieldset in fieldsets:
        
        title = fieldset['title']
        del fieldset['title']
        
        tab = {'border': False,
               'collapsible': False,
               'items': fieldset,
               'title': title}
        
        tabpanel.append_items(tab)

    return [tabpanel]