""" Author: R. Le Gac

"""

from gluon.storage import Storage
from modifier import Modifier
from navtree import Node


MSG_INVALID_NODE = 'Node object is not an instance of NodeBase class.'

MODIFIER_VIEWPORTS = 'modifier_viewports'


class ViewportModifier(Modifier):
    """Helper tool to customize the viewport widget of the application.
    
    """
    
    def __init__(self):
        """Initialize the modifier persistent data.
        
        """
        Modifier.__init__(self, MODIFIER_VIEWPORTS)
        self.data.nodes = []


    def add_node(self, *args):
        """Append nodes to the navigation tree.
        A node is an instance of the NodeBase class.
        
        """
        for el in args:
            if not isinstance(el, Node):
                raise ViewportModifierException(MSG_INVALID_NODE)
        
        self.data.nodes.extend(args)


class ViewportModifierException(BaseException): pass
