/**
 * The ComboBox is an Ext.form.ComboBox with an App.data.DirectStore. 
 * 
 * The type of this component is xcombobox.
 * 
 * @extends Ext.form.ComboBox 
 * @version
 *
 */
Ext.namespace('App.form');

App.form.ComboBox = Ext.extend(Ext.form.ComboBox, {

    /**
     * Predefined setting
     *
     */
    mode: 'remote',
    editable: false,
    selectOnFocus: true,
    triggerAction: 'all',
    typeAhead: true,
    
    /**
     * private method require by the ExtJs component model
     */	
    initComponent: function () {

        // defined the empty text from the field label
        if (this.fieldLabel && !this.emptyText) {
            this.emptyText = "Select a " + this.fieldLabel + " ...";	
        }

        // link the combobox to the data store
        this.store = App.getStore(this.store);

        // construct the underlying class. DON'T MOVE
        App.form.ComboBox.superclass.initComponent.call(this);

        // load the store if not yet done
        if (this.store.getCount() === 0) {
            this.store.load();    
        }
                
        // Set the default value when the comboBox is not yet expend
        this.store.on('load', function () {
            this.setValue(this.initialConfig.value);
        }, this);
    }
});

Ext.reg('xcombobox', App.form.ComboBox);
