/**
 * Plugin to render mathematics formula embedded in grid content.
 * The processing is performed by MathJax.
 * The MathJax library is loaded by the framework
 * 
 * @version
 *
 */

Ext.namespace('App.grid');
 
App.grid.MathJax = Ext.extend(Object, {

    init: function (grid) {

        function processMath(gridView) {
            var domEl = Ext.getDom(gridView.el);
            MathJax.Hub.Queue(["Typeset",MathJax.Hub, domEl]);
        }
        
        grid.getView().on('refresh', processMath, grid);
        grid.store.on('write', processMath, grid);
    }
});
    
Ext.preg('pGridMathJax', App.grid.MathJax);
