/**
 *  A border layout with a grid and its filter
 *  The type of this component is xgridwithfilter.
 *  
 *  @extends Ext.Panel
 *  @version
 *  
 */
Ext.namespace('App.grid');

App.grid.GridWithFilter = Ext.extend(App.BasePanelWithSelector, {

    initComponent: function() {

        var filter,
            grid;

        // collpase the grid filter panel
        this.items[1].collapsed = true;
        
        App.grid.GridWithFilter.superclass.initComponent.call(this);

        // bind the filter to the grid
        filter = this.findByType('xgridfilter')[0];
        grid = this.findByType('xgrid')[0];
        filter.bind(grid);

        // connect buttons
        this.goButton.hide();
        this.resetButton.on('click', filter.onReset, filter);
    }
});

Ext.reg('xgridwithfilter', App.grid.GridWithFilter);
